// STACKND.H
// Definition of template class StackNode
#ifndef STACKND_H
#define STACKND_H

template< class T > class Stack;  // forward declaration

template < class T >
class StackNode {
   friend class Stack< T >;
public:
   StackNode( const T & = 0, StackNode * = 0 );
   T getData() const;
   void setNextPtr( StackNode *nPtr ) { nextPtr = nPtr; }
   StackNode *getNextPtr() const { return nextPtr; }
private:
   T data;
   StackNode *nextPtr;
};

// Member function definitions for class StackNode
template < class T >
StackNode< T >::StackNode( const T &d, StackNode< T > *ptr )
{
   data = d;
   nextPtr = ptr;
}

template < class T >
T StackNode< T >::getData() const { return data; }

#endif
